书籍在其他数都出现k次的数组中找到只出现一次的数(7)0603

题目

给定一个整型数组arr和一个大于1的整数k。已知arr中只有1个数出现了1次,其他的数都出现了k次,请返回只出现了1次的数。

解答:

对此题进行思路转换,可以将此题,转换成k进制数。

k进制的两个数c和d,在i位上无进位相加的结果就是(c(i) + d(i) )% k。那么,如果k个相同的k进制进行无进位相加,相加的结果一定是没一位上都是0的k进制数。

首先设置一个变量eO,它是一个32位的k进制数,且每个位置上都是0。然后遍历arr,把遍历到的每一个整数都转换为k进制数,然后与eO进行无进位相加。遍历结束时,把32位的k进制数eORes转换为十进制整数,就是我们想要的结果。因为k个相同的k进制数无进位相加,结果一定是每一位上都是0的k进制数,所以只出现一次的那个数最终就会剩下来。

java 复制代码
public int onceNum(int[] arr, int k ){
    int[] eO = new int[32];
    for(int i = 0;i != arr.length;i++){
        setExclsiveOr(eO,arr[i],k);    
    }
    int res = getNumFromKSysNum(eO,k);
}


public void setExclusiverOr(int[] eO,int value,int k){
    int[] curKSysNum = getKSysNumFromNum(value,k);
    for(int i = 0;i!= eO.length;i++){
        eO[i] = (eO[i] + curKSysNum[i]) % k;
    }
}


public int[] getKSysNumFromNum(int value,int k){
    int[] res = new int[32];
    int index = 0;
    while(value != 0 ){
        res[index++] = value % k;
        value = value/k;
    }
    return res;
}

public int getNumFromKSysNum(int[] eO,int k){
    int res = 0;
    for(int i = eO.length - 1;i != -1; i--){
        res = res * k + eO[i];
    }
    return res;
}
相关推荐
花间相见几秒前
【计算基础|MySQL08】索引(上):为什么是 B+ 树
数据结构·mysql·算法·架构
吠品11 分钟前
Flutter 工程配本地 Maven 引 AAR,仓库声明为啥不生效
c语言·人工智能·算法
罗湖老棍子15 分钟前
【例题1】黑暗城堡(信息学奥赛一本通- P1486)
算法·图论·最短路·dijkstra·最小生成树·最短路径生成树
hetao173383731 分钟前
2026-10-20 hetao1733837 的刷题记录
c++·算法
碧海银沙音频科技研究院2 小时前
基于ATS308X的无线语音交互对话功能实现
人工智能·嵌入式硬件·深度学习·算法
尹玉玺3 小时前
从原子残片到天道公理:以德谟克利特思想全貌,重新定界西方唯物认知的历史层级与边界
人工智能·算法·架构
青少儿编程课堂3 小时前
蓝桥杯·全国青少年信息素养大赛·电子学会Python/C++考级:差分数组与区间修改实战解析
c++·python·算法·bfs·信息学竞赛
重生之小比特3 小时前
【算法拾光】二分查找|二分查找 + 再排序数组中查找元素的第一个和最后一个位置
算法·leetcode·职场和发展
零基础1233 小时前
基于模型的强化学习与不基于模型的强化学习:核心区别与实战选择
python·算法